=begin
#Shotstack

#Shotstack is a video, image and audio editing service that allows for the automated generation of videos, images and audio using JSON and a RESTful API.  You arrange and configure an edit and POST it to the API which will render your media and provide a file  location when complete.  For more details visit [shotstack.io](https://shotstack.io) or checkout our [getting started](https://shotstack.gitbook.io/docs/guides/getting-started) documentation. There are two main API's, one for editing and generating assets (Edit API) and one for managing hosted assets (Serve API).  The Edit API base URL is: <b>https://api.shotstack.io/{version}</b>  The Serve API base URL is: <b>https://api.shotstack.io/serve/{version}</b>

The version of the OpenAPI document: v1

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.0.0

=end

require 'date'
require 'time'

module Shotstack
  # Crop the sides of an asset by a relative amount. The size of the crop is specified using a scale between 0 and 1, relative to the screen width - i.e a left crop of 0.5 will crop half of the asset from the left, a top crop  of 0.25 will crop the top by quarter of the asset.
  class Crop
    # Crop from the top of the asset
    attr_accessor :top

    # Crop from the bottom of the asset
    attr_accessor :bottom

    # Crop from the left of the asset
    attr_accessor :left

    # Crop from the left of the asset
    attr_accessor :right

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'top' => :'top',
        :'bottom' => :'bottom',
        :'left' => :'left',
        :'right' => :'right'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'top' => :'Float',
        :'bottom' => :'Float',
        :'left' => :'Float',
        :'right' => :'Float'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shotstack::Crop` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shotstack::Crop`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'top')
        self.top = attributes[:'top']
      end

      if attributes.key?(:'bottom')
        self.bottom = attributes[:'bottom']
      end

      if attributes.key?(:'left')
        self.left = attributes[:'left']
      end

      if attributes.key?(:'right')
        self.right = attributes[:'right']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@top.nil? && @top > 1
        invalid_properties.push('invalid value for "top", must be smaller than or equal to 1.')
      end

      if !@top.nil? && @top < 0
        invalid_properties.push('invalid value for "top", must be greater than or equal to 0.')
      end

      if !@bottom.nil? && @bottom > 1
        invalid_properties.push('invalid value for "bottom", must be smaller than or equal to 1.')
      end

      if !@bottom.nil? && @bottom < 0
        invalid_properties.push('invalid value for "bottom", must be greater than or equal to 0.')
      end

      if !@left.nil? && @left > 1
        invalid_properties.push('invalid value for "left", must be smaller than or equal to 1.')
      end

      if !@left.nil? && @left < 0
        invalid_properties.push('invalid value for "left", must be greater than or equal to 0.')
      end

      if !@right.nil? && @right > 1
        invalid_properties.push('invalid value for "right", must be smaller than or equal to 1.')
      end

      if !@right.nil? && @right < 0
        invalid_properties.push('invalid value for "right", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@top.nil? && @top > 1
      return false if !@top.nil? && @top < 0
      return false if !@bottom.nil? && @bottom > 1
      return false if !@bottom.nil? && @bottom < 0
      return false if !@left.nil? && @left > 1
      return false if !@left.nil? && @left < 0
      return false if !@right.nil? && @right > 1
      return false if !@right.nil? && @right < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] top Value to be assigned
    def top=(top)
      if !top.nil? && top > 1
        fail ArgumentError, 'invalid value for "top", must be smaller than or equal to 1.'
      end

      if !top.nil? && top < 0
        fail ArgumentError, 'invalid value for "top", must be greater than or equal to 0.'
      end

      @top = top
    end

    # Custom attribute writer method with validation
    # @param [Object] bottom Value to be assigned
    def bottom=(bottom)
      if !bottom.nil? && bottom > 1
        fail ArgumentError, 'invalid value for "bottom", must be smaller than or equal to 1.'
      end

      if !bottom.nil? && bottom < 0
        fail ArgumentError, 'invalid value for "bottom", must be greater than or equal to 0.'
      end

      @bottom = bottom
    end

    # Custom attribute writer method with validation
    # @param [Object] left Value to be assigned
    def left=(left)
      if !left.nil? && left > 1
        fail ArgumentError, 'invalid value for "left", must be smaller than or equal to 1.'
      end

      if !left.nil? && left < 0
        fail ArgumentError, 'invalid value for "left", must be greater than or equal to 0.'
      end

      @left = left
    end

    # Custom attribute writer method with validation
    # @param [Object] right Value to be assigned
    def right=(right)
      if !right.nil? && right > 1
        fail ArgumentError, 'invalid value for "right", must be smaller than or equal to 1.'
      end

      if !right.nil? && right < 0
        fail ArgumentError, 'invalid value for "right", must be greater than or equal to 0.'
      end

      @right = right
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          top == o.top &&
          bottom == o.bottom &&
          left == o.left &&
          right == o.right
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [top, bottom, left, right].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Shotstack.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
